Index: /pykota/trunk/man/edpykota.1
===================================================================
--- /pykota/trunk/man/edpykota.1 (revision 837)
+++ /pykota/trunk/man/edpykota.1 (revision 935)
@@ -1,8 +1,8 @@
 .\" DO NOT MODIFY THIS FILE!  It was generated by help2man 1.29.
-.TH EDPYKOTA "1" "March 2003" "edpykota 0.99-unofficial" "PyKota Print Quota System"
+.TH EDPYKOTA "1" "April 2003" "edpykota 1.03beta2-unofficial" "PyKota Print Quota System"
 .SH NAME
-edpykota \- manual page for edpykota 0.99-unofficial
+edpykota \- manual page for edpykota 1.03beta2-unofficial
 .SH DESCRIPTION
-edpykota v0.99-unofficial (C) 2003 C@LL - Conseil Internet & Logiciels Libres
+edpykota v1.03beta2-unofficial (C) 2003 C@LL - Conseil Internet & Logiciels Libres
 A Print Quota editor for PyKota.
 .PP
@@ -24,4 +24,19 @@
 exist on the Quota Storage Server.
 .TP
+\fB\-d\fR | \fB\-\-delete\fR
+Deletes users/groups from the quota storage.
+Printers are never deleted.
+.TP
+\fB\-c\fR | \fB\-\-charge\fR p[,j]
+Sets the price per page and per job to charge
+for a particular printer. Job price is optional.
+If both are to be set, separate them with a comma.
+Floating point values are allowed.
+.TP
+\fB\-i\fR | \fB\-\-ingroups\fR g1[,g2...]
+Puts the users into each of the groups
+listed, separated by commas. The groups
+must already exist in the Quota Storage.
+.TP
 \fB\-u\fR | \fB\-\-users\fR
 Edit users print quotas, this is the default.
@@ -39,8 +54,27 @@
 print quotas
 .TP
+\fB\-n\fR | \fB\-\-noquota\fR
+Doesn't set a quota but only does accounting.
+.TP
 \fB\-r\fR | \fB\-\-reset\fR
 Resets the printed page counter for the user
 or group to zero. The life time page counter
 is kept unchanged.
+.TP
+\fB\-l\fR | \fB\-\-limitby\fR l
+Choose if the user/group is limited in printing
+by its account balance or by its page quota.
+The default value is 'quota'. Allowed values
+are 'quota' and 'balance'.
+.TP
+\fB\-b\fR | \fB\-\-balance\fR b
+Sets the user's account balance to b.
+Account balance may be increase or decreased
+if b is prefixed with + or -.
+WARNING : when decreasing account balance,
+the total paid so far by the user is decreased
+too.
+Groups don't have a real balance, but the
+sum of their users' account balance.
 .TP
 \fB\-S\fR | \fB\-\-softlimit\fR sl
@@ -66,8 +100,10 @@
 printer lp doesn't exist on the Quota Storage Server then nothing is done.
 .IP
-\f(CW$ edpykota --add --printer lp -S 50 -H 60 jerome\fR
+\f(CW$ edpykota --add --printer lp --ingroups coders,it -S 50 -H 60 jerome\fR
 .IP
 Same as above, but if either user jerome or printer lp doesn't exist
-on the Quota Storage Server they are automatically added.
+on the Quota Storage Server they are automatically added. Also
+user jerome is put into the groups "coders" and "it" which must
+already exist in the Quota Storage.
 WARNING : the CUPS PPD file for this printer must still be modified
 .IP
@@ -85,4 +121,32 @@
 well as every user whose name begins with 'jo'.
 Their life time page counter on each printer will be kept unchanged.
+.IP
+\f(CW$ edpykota --printer hpcolor --noquota jerome\fR
+.IP
+This will tell PyKota to not limit jerome when printing on the
+hpcolor printer. All his jobs will be allowed on this printer, but
+accounting of the pages he prints will still be kept.
+Print Quotas for jerome on other printers are unchanged.
+.IP
+\f(CW$ edpykota --limitby balance jerome\fR
+.IP
+This will tell PyKota to limit jerome by his account's balance
+when printing.
+.IP
+\f(CW$ edpykota --balance +10.0 jerome\fR
+.IP
+This will increase jerome's account balance by 10.0 (in your
+own currency). You can decrease the account balance with a
+dash prefix, and set it to a fixed amount with no prefix.
+.IP
+\f(CW$ edpykota --delete jerome rachel\fR
+.IP
+This will completely delete jerome and rachel from the Quota Storage
+database. All their quotas and jobs will be deleted too.
+.IP
+\f(CW$ edpykota --printer lp --charge 0.1\fR
+.IP
+This will set the page price for printer lp to 0.1. Job price
+will not be changed.
 .PP
 This program is free software; you can redistribute it and/or modify
Index: /pykota/trunk/man/repykota.1
===================================================================
--- /pykota/trunk/man/repykota.1 (revision 837)
+++ /pykota/trunk/man/repykota.1 (revision 935)
@@ -1,8 +1,8 @@
 .\" DO NOT MODIFY THIS FILE!  It was generated by help2man 1.29.
-.TH REPYKOTA "1" "March 2003" "repykota 0.99-unofficial" "PyKota Print Quota System"
+.TH REPYKOTA "1" "April 2003" "repykota 1.03beta2-unofficial" "PyKota Print Quota System"
 .SH NAME
-repykota \- manual page for repykota 0.99-unofficial
+repykota \- manual page for repykota 1.03beta2-unofficial
 .SH DESCRIPTION
-repykota v0.99-unofficial (C) 2003 C@LL - Conseil Internet & Logiciels Libres
+repykota v1.03beta2-unofficial (C) 2003 C@LL - Conseil Internet & Logiciels Libres
 .PP
 Generates print quota reports.
Index: /pykota/trunk/man/warnpykota.1
===================================================================
--- /pykota/trunk/man/warnpykota.1 (revision 837)
+++ /pykota/trunk/man/warnpykota.1 (revision 935)
@@ -1,8 +1,8 @@
 .\" DO NOT MODIFY THIS FILE!  It was generated by help2man 1.29.
-.TH WARNPYKOTA "1" "March 2003" "warnpykota 0.99-unofficial" "PyKota Print Quota System"
+.TH WARNPYKOTA "1" "April 2003" "warnpykota 1.03beta2-unofficial" "PyKota Print Quota System"
 .SH NAME
-warnpykota \- manual page for warnpykota 0.99-unofficial
+warnpykota \- manual page for warnpykota 1.03beta2-unofficial
 .SH DESCRIPTION
-warnpykota v0.99-unofficial (C) 2003 C@LL - Conseil Internet & Logiciels Libres
+warnpykota v1.03beta2-unofficial (C) 2003 C@LL - Conseil Internet & Logiciels Libres
 .PP
 Sends mail to users over print quota.
@@ -21,9 +21,9 @@
 .TP
 \fB\-u\fR | \fB\-\-users\fR
-Send mail to users over print quota, this is
-the default.
+Warns users over their print quota, this is the
+default.
 .TP
 \fB\-g\fR | \fB\-\-groups\fR
-Send mail to group administrators instead of users.
+Warns users whose groups quota are over limit.
 .TP
 \fB\-P\fR | \fB\-\-printer\fR p
@@ -49,5 +49,5 @@
 \f(CW$ warnpykota --groups --printer "laserjet*"\fR
 .IP
-This will warn all group administrators of groups which have exceeded
+This will warn all users of groups which have exceeded
 their print quota on any printer which name begins with "laserjet"
 .PP