Index: pykota/trunk/CREDITS
===================================================================
--- pykota/trunk/CREDITS (revision 1006)
+++ pykota/trunk/CREDITS (revision 1007)
@@ -41,4 +41,5 @@
     - Stefan Wold - Stockholm University
     - John Flynn - University of Belize
+    - Wayne Godoy - University of Belize
 
 ============================================================
Index: pykota/trunk/initscripts/pykota.schema
===================================================================
--- pykota/trunk/initscripts/pykota.schema (revision 1007)
+++ pykota/trunk/initscripts/pykota.schema (revision 1007)
@@ -0,0 +1,70 @@
+# $Id$
+#
+# pykota.schema
+#
+# LDAP Schema for Pykota Quota System
+# Version 0.2
+#
+# Written 2003-05-28 by Wayne Godoy and John Flynn <wgodoy =AT= ub -DOT- edu -DOT- bz>
+#
+# Modified by Jerome Alet 2003-06-01
+#
+# 16868.x       => Conseil Internet & Logiciels Libres
+# 16868.1.x     => Pykota
+# 16868.1.1.x   => attributes
+# 16868.1.2.x   => classes
+#
+#
+# THIS IS WORK UNDER HEAVY DEVELOPPMENT !
+#
+# USE AT YOUR OWN RISK, AND ONLY IF YOU PERFECTLY KNOW
+# WHAT YOU ARE DOING.
+#
+# WHEN LDAP SUPPORT WILL BE FINALIZED, YOU'LL KNOW IT !
+#
+
+## Pykota related LDAP attributes
+
+attributetype ( 1.3.6.1.4.1.16868.1.1.1 NAME 'pykotaLimitBy'
+        DESC 'How to limit the user : quota or balance'
+        EQUALITY caseIgnoreIA5Match
+        SYNTAX 1.3.6.1.4.1.1466.115.121.1.26 SINGLE-VALUE )
+
+attributetype ( 1.3.6.1.4.1.16868.1.1.2 NAME 'pykotaBalance'
+        DESC 'Current account balance for the user, float'
+        EQUALITY caseIgnoreIA5Match
+        SYNTAX 1.3.6.1.4.1.1466.115.121.1.26 SINGLE-VALUE )
+
+attributetype ( 1.3.6.1.4.1.16868.1.1.3 NAME 'pykotaLifeTimePaid'
+        DESC 'Total money paid by the user to fill his account balance, float'
+        EQUALITY caseIgnoreIA5Match
+        SYNTAX 1.3.6.1.4.1.1466.115.121.1.26 SINGLE-VALUE )
+
+attributetype ( 1.3.6.1.4.1.16868.1.1.4 NAME 'pykotaPricePerPage'
+        DESC 'Price per page for a printer, float'
+        EQUALITY caseIgnoreIA5Match
+        SYNTAX 1.3.6.1.4.1.1466.115.121.1.26 SINGLE-VALUE )
+
+attributetype ( 1.3.6.1.4.1.16868.1.1.3 NAME 'pykotaPricePerJob'
+        DESC 'Price per job for a printer, float'
+        EQUALITY caseIgnoreIA5Match
+        SYNTAX 1.3.6.1.4.1.1466.115.121.1.26 SINGLE-VALUE )
+
+
+## New Pykota User object type
+objectclass ( 1.3.6.1.4.1.16868.1.2.1 NAME 'pykotaUser' SUP top AUXILIARY
+        DESC 'PyKota Auxiliary User Account'
+        MUST ( uid )
+        MAY  ( pykotaLimitBy $ pykotaBalance $ pykotaLifeTimePaid )
+        
+## New Pykota Group object type
+objectclass ( 1.3.6.1.4.1.16868.1.2.2 NAME 'pykotaGroup' SUP top AUXILIARY
+        DESC 'PyKota Auxiliary Group'
+        MUST ( cn )
+        MAY  ( pykotaLimitBy )
+        
+## New Pykota Printer object type
+objectclass ( 1.3.6.1.4.1.16868.1.2.3 NAME 'pykotaPrinter' SUP top AUXILIARY
+        DESC 'PyKota Auxiliary Printer'
+        MUST ( cn )
+        MAY  ( pykotaPricePerPage $ pykotaPricePerJob )
Index: pykota/trunk/initscripts/README.ldap
===================================================================
--- pykota/trunk/initscripts/README.ldap (revision 1007)
+++ pykota/trunk/initscripts/README.ldap (revision 1007)
@@ -0,0 +1,31 @@
+# $Id$
+
+PyKota - Print Quota for CUPS and LPRng
+
+(c) 2003 Jerome Alet <alet@librelogiciel.com>
+This program is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2 of the License, or
+(at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program; if not, write to the Free Software
+Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
+
+============================================================
+
+Documentation for the pykota.schema file :
+------------------------------------------
+
+This file can be used to modify an existing LDAP directory
+to add the necessary attributes for use with PyKota.
+
+More help will be available in the future, when this schema        
+will be completed and LDAP support will be finalized.
+
+============================================================
Index: pykota/trunk/initscripts/README
===================================================================
--- pykota/trunk/initscripts/README (revision 952)
+++ pykota/trunk/initscripts/README (revision 1007)
@@ -34,4 +34,9 @@
     if you want to use PostgreSQL as the Quota Storage Backend.
     
+  * pykota.schema :  
+  
+    This file adds the necessary classes and attributes to an existing
+    LDAP directory for use with PyKota. Read this file for details.
+    
   * VERYOLDpykota-upgrade-postgresql.sql :
   