Index: pykota/trunk/initscripts/ldap/pykota-sample.ldif
===================================================================
--- pykota/trunk/initscripts/ldap/pykota-sample.ldif (revision 1017)
+++ pykota/trunk/initscripts/ldap/pykota-sample.ldif (revision 1018)
@@ -72,5 +72,5 @@
 
 dn: cn=apple,ou=Printers,ou=PyKota,dc=librelogiciel,dc=com
-objectClass: pykotaNamed
+objectClass: pykotaObject
 objectClass: pykotaPrinter
 cn: apple
@@ -80,5 +80,5 @@
 
 dn: cn=uniqueidentifier01,ou=UQuotas,ou=PyKota,dc=librelogiciel,dc=com
-objectClass: pykotaNamed
+objectClass: pykotaObject
 objectClass: pykotaUserPQuota
 cn: uniqueidentifier01
@@ -92,5 +92,5 @@
 
 dn: cn=uniqueidentifier02,ou=GQuotas,ou=PyKota,dc=librelogiciel,dc=com
-objectClass: pykotaNamed
+objectClass: pykotaObject
 objectClass: pykotaGroupPQuota
 cn: uniqueidentifier02
@@ -102,5 +102,5 @@
 
 dn: cn=uniqueidentifier03,ou=Jobs,ou=PyKota,dc=librelogiciel,dc=com
-objectClass: pykotaNamed
+objectClass: pykotaObject
 objectClass: pykotaJob
 cn: uniqueidentifier03
@@ -113,7 +113,7 @@
 
 dn: cn=uniqueidentifier04,ou=LastJobs,ou=PyKota,dc=librelogiciel,dc=com
-objectClass: pykotaNamed
+objectClass: pykotaObject
 objectClass: pykotaLastJob
 cn: uniqueidentifier04
 pykotaPrinterName: apple
-pykotaLastJobUUID: uniqueidentifier03
+pykotaLastJobIdent: uniqueidentifier03
Index: pykota/trunk/initscripts/ldap/pykota.schema
===================================================================
--- pykota/trunk/initscripts/ldap/pykota.schema (revision 1017)
+++ pykota/trunk/initscripts/ldap/pykota.schema (revision 1018)
@@ -110,6 +110,6 @@
 # pykotaAction
 attributetype ( 1.3.6.1.4.1.16868.1.1.14 NAME 'pykotaAction'
-        DESC 'Was the job allowed, or denied'
-        EQUALITY caseIgnoreIA5Match
+        DESC 'Was the job allowed, or denied : ( "ALLOW" |  "DENY" )'
+        EQUALITY caseExactIA5Match
         SYNTAX 1.3.6.1.4.1.1466.115.121.1.26 SINGLE-VALUE )
         
@@ -132,7 +132,7 @@
         SYNTAX 1.3.6.1.4.1.1466.115.121.1.26 SINGLE-VALUE )
         
-# pykotaLastJobUUID        
-attributetype ( 1.3.6.1.4.1.16868.1.1.18 NAME 'pykotaLastJobUUID'
-        DESC 'Last job uuid in the history'
+# pykotaLastJobIdent        
+attributetype ( 1.3.6.1.4.1.16868.1.1.18 NAME 'pykotaLastJobIdent'
+        DESC 'Identifies the last job in the history'
         EQUALITY caseExactIA5Match
         SYNTAX 1.3.6.1.4.1.1466.115.121.1.26 SINGLE-VALUE )
@@ -145,18 +145,18 @@
 objectclass ( 1.3.6.1.4.1.16868.1.2.1 NAME 'pykotaAccount' SUP top AUXILIARY
         DESC 'PyKota Auxiliary User Account'
-        MUST ( uid $ pykotaUserName )
-        MAY  ( pykotaLimitBy ) )
+        MUST ( uid )
+        MAY  ( pykotaUserName $ pykotaLimitBy ) )
         
 # pykotaGroup        
 objectclass ( 1.3.6.1.4.1.16868.1.2.2 NAME 'pykotaGroup' SUP top AUXILIARY
         DESC 'PyKota Auxiliary Group'
-        MUST ( cn $ pykotaGroupName )
-        MAY  ( pykotaLimitBy $ memberUid ) )
+        MUST ( cn )
+        MAY  ( pykotaGroupName $ pykotaLimitBy $ memberUid $ uniqueMember $ member ) )
         
 # pykotaPrinter        
 objectclass ( 1.3.6.1.4.1.16868.1.2.3 NAME 'pykotaPrinter' SUP top AUXILIARY
         DESC 'PyKota Printer'
-        MUST ( cn $ pykotaPrinterName )
-        MAY  ( pykotaPricePerPage $ pykotaPricePerJob ) )
+        MUST ( cn )
+        MAY  ( pykotaPrinterName $ pykotaPricePerPage $ pykotaPricePerJob ) )
         
 # pykotaUserPQuota        
@@ -181,15 +181,15 @@
 objectclass ( 1.3.6.1.4.1.16868.1.2.7 NAME 'pykotaAccountBalance' SUP top AUXILIARY
         DESC 'PyKota User account balance'
-        MUST ( pykotaUserName )
-        MAY  ( pykotaBalance $ pykotaLifeTimePaid ) )
+        MAY  ( pykotaUserName $ pykotaBalance $ pykotaLifeTimePaid ) )
         
 # pykotaLastJob        
 objectclass ( 1.3.6.1.4.1.16868.1.2.8 NAME 'pykotaLastJob' SUP top AUXILIARY
         DESC 'Last job information for a printer'
-        MUST ( pykotaPrinterName $ pykotaLastJobUUID ) )
+        MUST ( pykotaLastJobIdent )
+        MAY ( pykotaPrinterName ) ) 
         
-# pykotaNamed - Use it if you have to 
-objectclass ( 1.3.6.1.4.1.16868.1.2.9 NAME 'pykotaNamed' SUP top STRUCTURAL
-        DESC 'PyKota Named Object'
+# pykotaObject - Use it if you have to 
+objectclass ( 1.3.6.1.4.1.16868.1.2.9 NAME 'pykotaObject' SUP top STRUCTURAL
+        DESC 'PyKota Object'
         MUST ( cn ) )
         